/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *
 */
// https://issues.jboss.org/browse/TEIID-4407
// https://issues.jboss.org/browse/TEIID-4408
// https://issues.jboss.org/browse/TEIID-5923
package org.teiid.translator.salesforce.execution;

import static org.junit.jupiter.api.Assertions.assertEquals;

import java.sql.Time;
import java.util.List;
import java.util.TimeZone;

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.mockito.ArgumentCaptor;
import org.mockito.Mockito;
import org.teiid.cdk.api.TranslationUtility;
import org.teiid.core.util.ObjectConverterUtil;
import org.teiid.core.util.TimestampWithTimezone;
import org.teiid.core.util.UnitTestUtil;
import org.teiid.language.Delete;
import org.teiid.language.Update;
import org.teiid.metadata.RuntimeMetadata;
import org.teiid.query.unittest.RealMetadataFactory;
import org.teiid.query.unittest.TimestampUtil;
import org.teiid.translator.DataNotAvailableException;
import org.teiid.translator.ExecutionContext;
import org.teiid.translator.salesforce.SalesForceExecutionFactory;
import org.teiid.translator.salesforce.SalesforceConnection;
import org.teiid.translator.salesforce.Util;
import org.teiid.translator.salesforce.execution.visitors.TestVisitors;

import com.sforce.soap.partner.QueryResult;
import com.sforce.soap.partner.sobject.SObject;

@SuppressWarnings("nls")
public class TestUpdates {
    
    private static TranslationUtility translationUtility = new TranslationUtility(TestVisitors.exampleSalesforce());

    @BeforeAll
 	public static void oneTimeSetup() {
        Util.resetTimeZone();
        TimestampWithTimezone.resetCalendar(TimeZone.getTimeZone("GMT-1"));
    }

    @AfterAll
 	public static void oneTimeTeardown() {
        Util.resetTimeZone();
        TimestampWithTimezone.resetCalendar(null);
    }

    @Test
    public void testIds() throws Exception {
        Delete delete = (Delete) translationUtility.parseCommand("delete from contacts");
        
        SalesforceConnection connection = Mockito.mock(SalesforceConnection.class);
        
        SalesForceExecutionFactory config = new SalesForceExecutionFactory();
        
        DeleteExecutionImpl updateExecution = new DeleteExecutionImpl(config, delete, connection, Mockito.mock(RuntimeMetadata.class), Mockito.mock(ExecutionContext.class));
        
        ArgumentCaptor<String> queryArgument = ArgumentCaptor.forClass(String.class);
        QueryResult qr = new QueryResult();
        SObject so = new SObject();
        so.setType("Contact");
        so.addField("Id", "x");
        qr.setRecords(new SObject[] {so});
        qr.setSize(1);
        qr.setDone(true);
        
        Mockito.when(connection.query(queryArgument.capture(), Mockito.anyInt(), Mockito.anyBoolean())).thenReturn(qr);
        Mockito.when(connection.delete(new String[] {"x"})).thenReturn(1);
        
        while(true) {
            try {
                updateExecution.execute();
                Assertions.assertArrayEquals(new int[] {1}, updateExecution.getUpdateCounts());
                break;
            } catch(DataNotAvailableException e) {
                continue;
            }
        }
        
        Mockito.verify(connection, Mockito.times(1)).query(queryArgument.capture(), Mockito.anyInt(), Mockito.anyBoolean());
        
        String query = queryArgument.getValue();
        assertEquals("SELECT Id FROM Contact ", query);

    }

    @Test
 	public void testUpdateValues() throws Exception {
        TranslationUtility tu = new TranslationUtility(RealMetadataFactory.fromDDL(ObjectConverterUtil.convertFileToString(UnitTestUtil.getTestDataFile("sf.ddl")), "sf", "sf"));
        Update update = (Update) tu.parseCommand("update contact set birthdate = DATE'2000-01-01'");

        SalesforceConnection connection = Mockito.mock(SalesforceConnection.class);

        SalesForceExecutionFactory config = new SalesForceExecutionFactory();

        UpdateExecutionImpl updateExecution = new UpdateExecutionImpl(config, update, connection, Mockito.mock(RuntimeMetadata.class), Mockito.mock(ExecutionContext.class));

        ArgumentCaptor<String> queryArgument = ArgumentCaptor.forClass(String.class);
        QueryResult qr = new QueryResult();
        SObject so = new SObject();
        so.setType("Contact");
        so.addField("Id", "x");
        qr.setRecords(new SObject[] {so});
        qr.setSize(1);
        qr.setDone(true);

        ArgumentCaptor<List> data = ArgumentCaptor.forClass(List.class);

        Mockito.when(connection.query(queryArgument.capture(), Mockito.anyInt(), Mockito.anyBoolean())).thenReturn(qr);
        Mockito.when(connection.update(data.capture())).thenReturn(1);

        while(true) {
            try {
                updateExecution.execute();
                Assertions.assertArrayEquals(new int[] {1}, updateExecution.getUpdateCounts());
                break;
            } catch(DataNotAvailableException e) {
                continue;
            }
        }

        Mockito.verify(connection, Mockito.times(1)).query(queryArgument.capture(), Mockito.anyInt(), Mockito.anyBoolean());

        String query = queryArgument.getValue();
        assertEquals("SELECT Id FROM Contact ", query);

        List<DataPayload> payloads = data.getValue();
        assertEquals(TimestampUtil.createDate(100, 0, 1), payloads.get(0).getMessageElements().get(0).value);

        //spot check boolean and time values
        assertEquals(Boolean.TRUE, Util.toSalesforceObjectValue(Boolean.TRUE, Boolean.class));
        assertEquals(new com.sforce.ws.types.Time("02:01:01.000Z"), Util.toSalesforceObjectValue(TimestampUtil.createTime(1, 1, 1), Time.class));
    }
}
